diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/minstrel-ht-wifi-manager.h ns-3.31/src/wifi/model/minstrel-ht-wifi-manager.h
--- ns-3.30.1/src/wifi/model/minstrel-ht-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/minstrel-ht-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -45,14 +45,14 @@
  */
 struct McsGroup
 {
-  uint8_t streams; ///< streams
-  uint8_t sgi; ///< short guard interval (0 or 1)
+  uint8_t streams;  ///< streams
+  uint8_t sgi;      ///< short guard interval (0 or 1)
   uint16_t chWidth; ///< channel width (MHz)
-  bool isVht; ///< is VHT?
+  bool isVht;       ///< is VHT?
   bool isSupported; ///< is supported?
   // To accurately account for TX times, we separate the TX time of the first
   // MPDU in an A-MPDU from the rest of the MPDUs.
-  TxTime ratesTxTimeTable; ///< rates transmit time table
+  TxTime ratesTxTimeTable;          ///< rates transmit time table
   TxTime ratesFirstMpduTxTimeTable; ///< rates MPDU transmit time table
 };
 
@@ -93,7 +93,7 @@
   uint32_t numSamplesSkipped;   //!< Number of times this rate statistics were not updated because no attempts have been made.
   uint64_t successHist;         //!< Aggregate of all transmission successes.
   uint64_t attemptHist;         //!< Aggregate of all transmission attempts.
-  double throughput;            //!< Throughput of this rate (in pkts per second).
+  double throughput;            //!< Throughput of this rate (in packets per second).
 };
 
 /**
@@ -113,9 +113,9 @@
   uint8_t m_col;                  //!< Sample table column.
   uint8_t m_index;                //!< Sample table index.
   bool m_supported;               //!< If the rates of this group are supported by the station.
-  uint16_t m_maxTpRate;           //!< The max throughput rate of this group.
-  uint16_t m_maxTpRate2;          //!< The second max throughput rate of this group.
-  uint16_t m_maxProbRate;         //!< The highest success probability rate of this group.
+  uint16_t m_maxTpRate;           //!< The max throughput rate of this group in bps.
+  uint16_t m_maxTpRate2;          //!< The second max throughput rate of this group in bps.
+  uint16_t m_maxProbRate;         //!< The highest success probability rate of this group in bps.
   HtMinstrelRate m_ratesTable;    //!< Information about rates of this group.
 };
 
@@ -129,13 +129,13 @@
  * Constants for maximum values.
  */
 
-static const uint8_t MAX_SUPPORTED_STREAMS = 4;  //!< Maximal number of streams supported by the phy layer.
+static const uint8_t MAX_SUPPORTED_STREAMS = 4;  //!< Maximal number of streams supported by the PHY layer.
 static const uint8_t MAX_HT_STREAM_GROUPS = 4;   //!< Maximal number of groups per stream in HT (2 possible channel widths and 2 possible SGI configurations).
 static const uint8_t MAX_VHT_STREAM_GROUPS = 8;  //!< Maximal number of groups per stream in VHT (4 possible channel widths and 2 possible SGI configurations).
 static const uint8_t MAX_HT_GROUP_RATES = 8;     //!< Number of rates (or MCS) per HT group.
 static const uint8_t MAX_VHT_GROUP_RATES = 10;   //!< Number of rates (or MCS) per VHT group.
-static const uint8_t MAX_HT_WIDTH = 40;          //!< Maximal channel width.
-static const uint8_t MAX_VHT_WIDTH = 160;        //!< Maximal channel width.
+static const uint8_t MAX_HT_WIDTH = 40;          //!< Maximal channel width in MHz.
+static const uint8_t MAX_VHT_WIDTH = 160;        //!< Maximal channel width in MHz.
 
 /**
  * \brief Implementation of Minstrel HT Rate Control Algorithm
@@ -147,7 +147,7 @@
  * Minstrel-HT is designed for high-latency devices that implement a
  * Multiple Rate Retry (MRR) chain. This kind of device does
  * not give feedback for every frame retransmission, but only when a frame
- * was correctly transmitted (an ACK is received) or a frame transmission
+ * was correctly transmitted (an Ack is received) or a frame transmission
  * completely fails (all retransmission attempts fail).
  * The MRR chain is used to advise the hardware about which rate to use
  * when retransmitting a frame.
@@ -178,8 +178,12 @@
  * each interval. However, it samples less often the low rates and high
  * probability of error rates.
  *
- * When this rate control is configured but HT and VHT are not supported,
+ * When this rate control is configured but non-legacy modes are not supported,
  * Minstrel-HT uses legacy Minstrel (minstrel-wifi-manager) for rate control.
+ *
+ * This RAA does not support HE modes yet and will error
+ * exit if the user tries to configure this RAA with a Wi-Fi MAC
+ * that supports 802.11ax or higher.
  */
 class MinstrelHtWifiManager : public WifiRemoteStationManager
 {
@@ -225,22 +229,20 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
   WifiTxVector DoGetRtsTxVector (WifiRemoteStation *station);
-  void DoReportAmpduTxStatus (WifiRemoteStation *station,
-                              uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus,
-                              double rxSnr, double dataSnr);
-  bool IsLowLatency (void) const;
+  void DoReportAmpduTxStatus (WifiRemoteStation *station, uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus,
+                              double rxSnr, double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   bool DoNeedRetransmission (WifiRemoteStation *st, Ptr<const Packet> packet, bool normally);
 
   /**
    * Check the validity of a combination of number of streams, chWidth and mode.
    *
-   * \param phy pointer to the wifi phy
+   * \param phy pointer to the wifi PHY
    * \param streams the number of streams
    * \param chWidth the channel width (MHz)
    * \param mode the wifi mode
@@ -251,7 +253,7 @@
   /**
    * Estimates the TxTime of a frame with a given mode and group (stream, guard interval and channel width).
    *
-   * \param phy pointer to the wifi phy
+   * \param phy pointer to the wifi PHY
    * \param streams the number of streams
    * \param sgi short guard interval enabled (0 or 1)
    * \param chWidth the channel width (MHz)
@@ -263,7 +265,7 @@
                                 uint16_t chWidth, WifiMode mode, MpduType mpduType);
 
   /**
-   * Obtain the TXtime saved in the group information.
+   * Obtain the TxTime saved in the group information.
    *
    * \param groupId the group ID
    * \param mode the wifi mode
@@ -281,7 +283,7 @@
   void AddMpduTxTime (uint8_t groupId, WifiMode mode, Time t);
 
   /**
-   * Obtain the TXtime saved in the group information.
+   * Obtain the TxTime saved in the group information.
    *
    * \param groupId the group ID
    * \param mode the wifi mode
@@ -308,8 +310,8 @@
    * Update the number of sample count variables.
    *
    * \param station the wifi remote station
-   * \param nSuccessfulMpdus
-   * \param nFailedMpdus
+   * \param nSuccessfulMpdus the number of successfully received MPDUs
+   * \param nFailedMpdus the number of failed MPDUs
    */
   void UpdatePacketCounters (MinstrelHtWifiRemoteStation *station, uint8_t nSuccessfulMpdus, uint8_t nFailedMpdus);
 
@@ -332,12 +334,12 @@
    * Find a rate to use from Minstrel Table.
    *
    * \param station the minstrel HT wifi remote station
-   * \returns the rate
+   * \returns the rate in bps
    */
   uint16_t FindRate (MinstrelHtWifiRemoteStation *station);
 
   /**
-   * Updating the Minstrel Table every 1/10 seconds.
+   * Update the Minstrel Table every 1/10 seconds.
    *
    * \param station the minstrel HT wifi remote station
    */
@@ -356,8 +358,8 @@
    * \param station the minstrel HT wifi remote station
    * \param groupId the group ID
    * \param rateId the rate ID
-   * \param ewmaProb
-   * \returns the throughput
+   * \param ewmaProb the EWMA probability
+   * \returns the throughput in bps
    */
   double CalculateThroughput (MinstrelHtWifiRemoteStation *station, uint8_t groupId, uint8_t rateId, double ewmaProb);
 
@@ -406,8 +408,8 @@
    *
    * There are four main parts:
    *  - wait for DIFS (sense idle channel)
-   *  - ACK timeouts
-   *  - DATA transmission
+   *  - Ack timeouts
+   *  - Data transmission
    *  - backoffs according to CW
    *
    * \param dataTransmissionTime the data transmission time
@@ -517,7 +519,7 @@
   uint16_t GetIndex (uint8_t groupId, uint8_t rateId);
 
   /**
-   * Returns the groupId of a HT MCS with the given number of streams, if using sgi and the channel width used.
+   * Returns the groupId of a HT MCS with the given number of streams, if using SGI and the channel width used.
    *
    * \param txstreams the number of streams
    * \param sgi short guard interval enabled (0 or 1)
@@ -527,7 +529,7 @@
   uint8_t GetHtGroupId (uint8_t txstreams, uint8_t sgi, uint16_t chWidth);
 
   /**
-   * Returns the groupId of a VHT MCS with the given number of streams, if using sgi and the channel width used.
+   * Returns the groupId of a VHT MCS with the given number of streams, if using SGI and the channel width used.
    *
    * \param txstreams the number of streams
    * \param sgi short guard interval enabled (0 or 1)
@@ -569,7 +571,7 @@
   uint8_t m_lookAroundRate;  //!< The % to try other rates than our current rate.
   uint8_t m_ewmaLevel;       //!< Exponential weighted moving average level (or coefficient).
   uint8_t m_nSampleCol;      //!< Number of sample columns.
-  uint32_t m_frameLength;    //!< Frame length used for calculate modes TxTime.
+  uint32_t m_frameLength;    //!< Frame length used for calculate modes TxTime in bytes.
   uint8_t m_numGroups;       //!< Number of groups Minstrel should consider.
   uint8_t m_numRates;        //!< Number of rates per group Minstrel should consider.
   bool m_useVhtOnly;         //!< If only VHT MCS should be used, instead of HT and VHT.
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/minstrel-wifi-manager.cc ns-3.31/src/wifi/model/minstrel-wifi-manager.cc
--- ns-3.30.1/src/wifi/model/minstrel-wifi-manager.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/minstrel-wifi-manager.cc	2020-06-27 17:38:30.000000000 -0700
@@ -59,7 +59,7 @@
                    MakeTimeAccessor (&MinstrelWifiManager::m_updateStats),
                    MakeTimeChecker ())
     .AddAttribute ("LookAroundRate",
-                   "the percentage to try other rates",
+                   "The percentage to try other rates",
                    UintegerValue (10),
                    MakeUintegerAccessor (&MinstrelWifiManager::m_lookAroundRate),
                    MakeUintegerChecker<uint8_t> ())
@@ -216,9 +216,6 @@
       InitSampleTable (station);
       RateInit (station);
       station->m_initialized = true;
-      std::ostringstream tmp;
-      tmp << "minstrel-stats-" << station->m_state->m_address << ".txt";
-      station->m_statsFile.open (tmp.str ().c_str (), std::ios::out);
     }
 }
 
@@ -232,7 +229,7 @@
  *  1  | Best throughput  | Random rate       | Best throughput
  *  2  | Random rate      | Best throughput   | Next best throughput
  *  3  | Best probability | Best probability  | Best probability
- *  4  | Lowest Baserate  | Lowest baserate   | Lowest baserate
+ *  4  | Lowest base rate | Lowest base rate  | Lowest base rate
  *
  * Note: For clarity, multiple blocks of if's and else's are used
  * After failing max retry times, DoReportFinalDataFailed will be called
@@ -372,7 +369,6 @@
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   if (!station->m_initialized)
@@ -396,7 +392,6 @@
   uint16_t channelWidth = GetChannelWidth (station);
   if (channelWidth > 20 && channelWidth != 22)
     {
-      //avoid to use legacy rate adaptation algorithms for IEEE 802.11n/ac
       channelWidth = 20;
     }
   WifiTxVector rtsTxVector;
@@ -484,7 +479,7 @@
       station->m_sampleRate = idx;
 
       /* From Linux implementation:
-       * Decide if direct ( 1st mrr stage) or indirect (2nd mrr stage)
+       * Decide if direct ( 1st MRR stage) or indirect (2nd MRR stage)
        * rate sampling method should be used.
        * Respect such rates that are not sampled for 20 iterations.
        */
@@ -561,7 +556,7 @@
   for (uint8_t i = 0; i < station->m_nModes; i++)
     {
 
-      //calculate the perfect tx time for this rate
+      //calculate the perfect TX time for this rate
       txTime = station->m_minstrelTable[i].perfectTxTime;
 
       //just for initialization
@@ -593,7 +588,7 @@
             }
           else
             {
-              //ewma probability (cast for gcc 3.4 compatibility)
+              //EWMA probability (cast for gcc 3.4 compatibility)
               tempProb = ((tempProb * (100 - m_ewmaLevel)) + (station->m_minstrelTable[i].ewmaProb * m_ewmaLevel) ) / 100;
 
               station->m_minstrelTable[i].ewmaProb = tempProb;
@@ -650,7 +645,7 @@
   uint32_t max_tp = 0;
   uint8_t index_max_tp = 0, index_max_tp2 = 0;
 
-  //go find max throughput, second maximum throughput, high probability succ
+  //go find max throughput, second maximum throughput, high probability of success
   NS_LOG_DEBUG ("Finding the maximum throughput, second maximum throughput, and highest probability");
   NS_LOG_DEBUG ("Index-Rate\t\tT-put\tEWMA");
   for (uint8_t i = 0; i < station->m_nModes; i++)
@@ -719,14 +714,14 @@
 MinstrelWifiManager::DoReportRxOk (WifiRemoteStation *st, double rxSnr, WifiMode txMode)
 {
   NS_LOG_FUNCTION (this << st << rxSnr << txMode);
-  NS_LOG_DEBUG ("DoReportRxOk m_txrate=" << ((MinstrelWifiRemoteStation *)st)->m_txrate);
+  NS_LOG_DEBUG ("DoReportRxOk m_txrate=" << static_cast<MinstrelWifiRemoteStation*> (st)->m_txrate);
 }
 
 void
 MinstrelWifiManager::DoReportRtsFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelWifiRemoteStation *station = (MinstrelWifiRemoteStation *)st;
+  MinstrelWifiRemoteStation *station = static_cast<MinstrelWifiRemoteStation*> (st);
   NS_LOG_DEBUG ("DoReportRtsFailed m_txrate=" << station->m_txrate);
   station->m_shortRetry++;
 }
@@ -741,7 +736,7 @@
 MinstrelWifiManager::DoReportFinalRtsFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelWifiRemoteStation *station = (MinstrelWifiRemoteStation *)st;
+  MinstrelWifiRemoteStation *station = static_cast<MinstrelWifiRemoteStation*> (st);
   UpdateRetry (station);
 }
 
@@ -749,7 +744,7 @@
 MinstrelWifiManager::DoReportDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelWifiRemoteStation *station = (MinstrelWifiRemoteStation *)st;
+  MinstrelWifiRemoteStation *station = static_cast<MinstrelWifiRemoteStation*> (st);
   NS_LOG_DEBUG ("DoReportDataFailed " << station << "\t rate " << station->m_txrate << "\tlongRetry \t" << station->m_longRetry);
   CheckInit (station);
   if (!station->m_initialized)
@@ -761,11 +756,11 @@
 }
 
 void
-MinstrelWifiManager::DoReportDataOk (WifiRemoteStation *st,
-                                     double ackSnr, WifiMode ackMode, double dataSnr)
+MinstrelWifiManager::DoReportDataOk (WifiRemoteStation *st, double ackSnr, WifiMode ackMode,
+                                     double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss)
 {
-  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr);
-  MinstrelWifiRemoteStation *station = (MinstrelWifiRemoteStation *) st;
+  NS_LOG_FUNCTION (this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
+  MinstrelWifiRemoteStation *station = static_cast<MinstrelWifiRemoteStation*> (st);
 
   CheckInit (station);
   if (!station->m_initialized)
@@ -796,7 +791,7 @@
 MinstrelWifiManager::DoReportFinalDataFailed (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelWifiRemoteStation *station = (MinstrelWifiRemoteStation *) st;
+  MinstrelWifiRemoteStation *station = static_cast<MinstrelWifiRemoteStation*> (st);
 
   CheckInit (station);
   if (!station->m_initialized)
@@ -860,7 +855,7 @@
 MinstrelWifiManager::DoGetDataTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelWifiRemoteStation *station = (MinstrelWifiRemoteStation *) st;
+  MinstrelWifiRemoteStation *station = static_cast<MinstrelWifiRemoteStation*> (st);
   return GetDataTxVector (station);
 }
 
@@ -868,7 +863,7 @@
 MinstrelWifiManager::DoGetRtsTxVector (WifiRemoteStation *st)
 {
   NS_LOG_FUNCTION (this << st);
-  MinstrelWifiRemoteStation *station = (MinstrelWifiRemoteStation *) st;
+  MinstrelWifiRemoteStation *station = static_cast<MinstrelWifiRemoteStation*> (st);
   return GetRtsTxVector (station);
 }
 
@@ -876,7 +871,7 @@
 MinstrelWifiManager::DoNeedRetransmission (WifiRemoteStation *st, Ptr<const Packet> packet, bool normally)
 {
   NS_LOG_FUNCTION (this << st << packet << normally);
-  MinstrelWifiRemoteStation *station = (MinstrelWifiRemoteStation *)st;
+  MinstrelWifiRemoteStation *station = static_cast<MinstrelWifiRemoteStation*> (st);
 
   CheckInit (station);
   if (!station->m_initialized)
@@ -895,12 +890,6 @@
     }
 }
 
-bool
-MinstrelWifiManager::IsLowLatency (void) const
-{
-  return true;
-}
-
 uint16_t
 MinstrelWifiManager::GetNextSample (MinstrelWifiRemoteStation *station)
 {
@@ -946,7 +935,7 @@
       station->m_minstrelTable[i].adjustedRetryCount = 1;
       //Emulating minstrel.c::ath_rate_ctl_reset
       //We only check from 2 to 10 retries. This guarantee that
-      //at least one retry is permitter.
+      //at least one retry is permitted.
       Time totalTxTimeWithGivenRetries = Seconds (0.0); //tx_time in minstrel.c
       NS_LOG_DEBUG (" Calculating the number of retries");
       for (uint32_t retries = 2; retries < 11; retries++)
@@ -972,14 +961,14 @@
   NS_LOG_FUNCTION (this << dataTransmissionTime << shortRetries << longRetries);
   //See rc80211_minstrel.c
 
-  //First transmission (DATA + ACK timeout)
+  //First transmission (Data + Ack timeout)
   Time tt = dataTransmissionTime + GetMac ()->GetAckTimeout ();
 
   uint32_t cwMax = 1023;
   uint32_t cw = 31;
   for (uint32_t retry = 0; retry < longRetries; retry++)
     {
-      //Add one re-transmission (DATA + ACK timeout)
+      //Add one re-transmission (Data + Ack timeout)
       tt += dataTransmissionTime + GetMac ()->GetAckTimeout ();
 
       //Add average back off (half the current contention window)
@@ -1043,6 +1032,13 @@
 void
 MinstrelWifiManager::PrintTable (MinstrelWifiRemoteStation *station)
 {
+  if (!station->m_statsFile.is_open ())
+    {
+      std::ostringstream tmp;
+      tmp << "minstrel-stats-" << station->m_state->m_address << ".txt";
+      station->m_statsFile.open (tmp.str ().c_str (), std::ios::out);
+    }
+
   station->m_statsFile << "best   _______________rate________________    ________statistics________    ________last_______    ______sum-of________\n" <<
     "rate  [      name       idx airtime max_tp]  [avg(tp) avg(prob) sd(prob)]  [prob.|retry|suc|att]  [#success | #attempts]\n";
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/wifi/model/minstrel-wifi-manager.h ns-3.31/src/wifi/model/minstrel-wifi-manager.h
--- ns-3.30.1/src/wifi/model/minstrel-wifi-manager.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/wifi/model/minstrel-wifi-manager.h	2020-06-27 17:38:30.000000000 -0700
@@ -45,14 +45,14 @@
   uint32_t retryCount;          ///< retry limit
   uint32_t adjustedRetryCount;  ///< adjust the retry limit for this rate
   uint32_t numRateAttempt;      ///< how many number of attempts so far
-  uint32_t numRateSuccess;      ///< number of successful pkts
-  uint32_t prob;                ///< (# pkts success )/(# total pkts)
+  uint32_t numRateSuccess;      ///< number of successful packets
+  uint32_t prob;                ///< (# packets success)/(# total packets)
   /**
    * EWMA calculation
    * ewma_prob =[prob *(100 - ewma_level) + (ewma_prob_old * ewma_level)]/100
    */
   uint32_t ewmaProb;
-  uint32_t throughput;  ///< throughput of a rate
+  uint32_t throughput;  ///< throughput of a rate in bps
 
   uint32_t prevNumRateAttempt;  //!< Number of transmission attempts with previous rate.
   uint32_t prevNumRateSuccess;  //!< Number of successful frames transmitted with previous rate.
@@ -87,25 +87,25 @@
   /**
    * To keep track of the current position in the our random sample table
    * going row by row from 1st column until the 10th column(Minstrel defines 10)
-   * then we wrap back to the row 1 col 1.
+   * then we wrap back to the row 1 column 1.
    * note: there are many other ways to do this.
    */
-  uint8_t m_col;                 ///< vector index
+  uint8_t m_col;                 ///< column index
   uint8_t m_index;               ///< vector index
-  uint16_t m_maxTpRate;          ///< the current throughput rate
-  uint16_t m_maxTpRate2;         ///< second highest throughput rate
-  uint16_t m_maxProbRate;        ///< rate with highest prob of success
+  uint16_t m_maxTpRate;          ///< the current throughput rate in bps
+  uint16_t m_maxTpRate2;         ///< second highest throughput rate in bps
+  uint16_t m_maxProbRate;        ///< rate with highest probability of success in bps
   uint8_t m_nModes;              ///< number of modes supported
   int m_totalPacketsCount;       ///< total number of packets as of now
   int m_samplePacketsCount;      ///< how many packets we have sample so far
-  int m_numSamplesDeferred;      ///< number samles deferred
+  int m_numSamplesDeferred;      ///< number samples deferred
   bool m_isSampling;             ///< a flag to indicate we are currently sampling
-  uint16_t m_sampleRate;         ///< current sample rate
+  uint16_t m_sampleRate;         ///< current sample rate in bps
   bool m_sampleDeferred;         ///< a flag to indicate sample rate is on the second stage
-  uint32_t m_shortRetry;         ///< short retries such as control packts
+  uint32_t m_shortRetry;         ///< short retries such as control packets
   uint32_t m_longRetry;          ///< long retries such as data packets
   uint32_t m_retry;              ///< total retries short + long
-  uint16_t m_txrate;             ///< current transmit rate
+  uint16_t m_txrate;             ///< current transmit rate in bps
   bool m_initialized;            ///< for initializing tables
   MinstrelRate m_minstrelTable;  ///< minstrel table
   SampleRate m_sampleTable;      ///< sample table
@@ -124,10 +124,10 @@
  * that it considers successful, and spends a fraction of its time
  * doing 'look around' by trying other rates.
  *
- * Minstrel is appropriate for non-HT/VHT/HE configurations; for HT/VHT/HE
- * (i.e. 802.11n/ac/ax), users should use MinstrelHtWifiManager instead.
+ * Minstrel is appropriate for non-HT configurations; for HT (i.e. 802.11n
+ * or higher), users should use MinstrelHtWifiManager instead.
  * Minstrel will error exit if the user tries to configure it with a
- * Wi-Fi MAC that has VhtSupported, HtSupported or HeSupported set.
+ * Wi-Fi MAC that supports 802.11n or higher.
  *
  * Some notes on this implementation follow.  The implementation has
  * been adapted to bring it closer to the Linux implementation.
@@ -181,29 +181,29 @@
   int64_t AssignStreams (int64_t stream);
 
   /**
-   * updating the rate
+   * Update the rate.
    *
    * \param station the station object
    */
   void UpdateRate (MinstrelWifiRemoteStation *station);
 
   /**
-   * updating the Minstrel Table every 1/10 seconds
+   * Update the Minstrel Table every 1/10 seconds.
    *
    * \param station the station object
    */
   void UpdateStats (MinstrelWifiRemoteStation *station);
 
   /**
-   * find a rate to use from Minstrel Table
+   * Find a rate to use from Minstrel Table.
    *
    * \param station the station object
-   * \returns the rate
+   * \returns the rate in bps
    */
   uint16_t FindRate (MinstrelWifiRemoteStation *station);
 
   /**
-   * Get data transmit vector
+   * Get data transmit vector.
    *
    * \param station the station object
    * \returns WifiTxVector
@@ -211,7 +211,7 @@
   WifiTxVector GetDataTxVector (MinstrelWifiRemoteStation *station);
 
   /**
-   * Get RTS transmit vector
+   * Get RTS transmit vector.
    *
    * \param station the station object
    * \returns WifiTxVector
@@ -219,36 +219,36 @@
   WifiTxVector GetRtsTxVector (MinstrelWifiRemoteStation *station);
 
   /**
-   * Count retries
+   * Get the number of retries.
    *
    * \param station the station object
-   * \returns the number if retries
+   * \returns the number of retries
    */
   uint32_t CountRetries (MinstrelWifiRemoteStation *station);
 
   /**
-   * Update packet counters
+   * Update packet counters.
    *
    * \param station the station object
    */
   void UpdatePacketCounters (MinstrelWifiRemoteStation *station);
 
   /**
-   * update the number of retries and reset accordingly
+   * Update the number of retries and reset accordingly.
    *
    * \param station the station object
    */
   void UpdateRetry (MinstrelWifiRemoteStation *station);
 
   /**
-   * check for initializations
+   * Check for initializations.
    *
    * \param station the station object
    */
   void CheckInit (MinstrelWifiRemoteStation *station);
 
   /**
-   * initialize Sample Table
+   * Initialize Sample Table.
    *
    * \param station the station object
    */
@@ -264,8 +264,8 @@
   void DoReportDataFailed (WifiRemoteStation *station);
   void DoReportRtsOk (WifiRemoteStation *station,
                       double ctsSnr, WifiMode ctsMode, double rtsSnr);
-  void DoReportDataOk (WifiRemoteStation *station,
-                       double ackSnr, WifiMode ackMode, double dataSnr);
+  void DoReportDataOk (WifiRemoteStation *station, double ackSnr, WifiMode ackMode,
+                       double dataSnr, uint16_t dataChannelWidth, uint8_t dataNss);
   void DoReportFinalRtsFailed (WifiRemoteStation *station);
   void DoReportFinalDataFailed (WifiRemoteStation *station);
   WifiTxVector DoGetDataTxVector (WifiRemoteStation *station);
@@ -274,10 +274,9 @@
   bool DoNeedRetransmission (WifiRemoteStation *st,
                                  Ptr<const Packet> packet, bool normally);
 
-  bool IsLowLatency (void) const;
 
   /**
-   * for estimating the TxTime of a packet with a given mode
+   * Estimate the TxTime of a packet with a given mode.
    *
    * \param mode Wi-Fi mode
    * \returns the transmission time
@@ -292,14 +291,14 @@
   void AddCalcTxTime (WifiMode mode, Time t);
 
   /**
-   * initialize Minstrel Table
+   * Initialize Minstrel Table.
    *
    * \param station the station object
    */
   void RateInit (MinstrelWifiRemoteStation *station);
 
   /**
-   * getting the next sample from Sample Table
+   * Get the next sample from Sample Table.
    *
    * \param station the station object
    * \returns the next sample
@@ -318,8 +317,8 @@
    *
    * There are four main parts:
    *  - wait for DIFS (sense idle channel)
-   *  - ACK timeouts
-   *  - DATA transmission
+   *  - Ack timeouts
+   *  - Data transmission
    *  - backoffs according to CW
    *
    * \param dataTransmissionTime the data transmission time
@@ -330,14 +329,14 @@
   Time CalculateTimeUnicastPacket (Time dataTransmissionTime, uint32_t shortRetries, uint32_t longRetries);
 
   /**
-   * printing Sample Table
+   * Print Sample Table.
    *
    * \param station the station object
    */
   void PrintSampleTable (MinstrelWifiRemoteStation *station);
 
   /**
-   * printing Minstrel Table
+   * Print Minstrel Table.
    *
    * \param station the station object
    */
@@ -348,7 +347,7 @@
    * Essentially a map from WifiMode to its corresponding transmission time
    * to transmit a reference packet.
    */
-  typedef std::map<WifiMode,Time> TxTime;
+  typedef std::map<WifiMode, Time> TxTime;
 
   TxTime m_calcTxTime;      ///< to hold all the calculated TxTime for all modes
   Time m_updateStats;       ///< how frequent do we calculate the stats (1/10 seconds)
